            #GIT_CMT=3f71fd61d778b8e07505d6b6f5a86c31ec7263e4
%global debug_package %{nil}
%global openssl_version 1.1.0h
%global openssl_tag OpenSSL_1_1_0h

#
# Example ARCHIVE Generation:
# export COMMIT=b6e48ec6
# export VERSION=1.1
# export RELEASE=1.el7
# rpmdev-setuptree
# git archive --format=tar --prefix=edk2-${VERSION}/ ${COMMIT} | xz -9ev > ~/rpmbuild/SOURCES/edk2-${VERSION}-${RELEASE}.tar.xz
#
# Copy over patches:
# cp buildrpm/ol7/*.patch ~/rpmbuild/SOURCES
#
# Build the RPMs:
# rpmbuild -ba buildrpm/ol7/edk2.spec
#
Name:		edk2
Version:	1.1
Release:    1.el7
Epoch:		1
Summary:	UEFI Firmware for 64-bit virtual machines

Group:		Applications/Emulators
License:	BSD and OpenSSL
URL:		http://www.tianocore.org
Source0: edk2-1.1.tar.bz2

Patch3:         0001-OvmfPkg-don-t-lock-lock-umb-when-running-csm.patch
Patch4:		0001-MdeModulePkg-TerminalDxe-add-other-text-resolutions.patch
Patch5:		0001-EXCLUDE_SHELL_FROM_FD.patch

Patch10:	0001-OvmfPkg-SmbiosPlatformDxe-install-legacy-QEMU-tables.patch
Patch11:	0002-OvmfPkg-SmbiosPlatformDxe-install-patch-default-lega.patch
Patch12:	0003-OvmfPkg-SmbiosPlatformDxe-install-patch-default-lega.patch

Patch20:	0001-OvmfPkg-EnrollDefaultKeys-application-for-enrolling-.patch

Patch30:	0001-tools_def.template-take-GCC4-_-IA32-X64-prefixes-fro.patch

%ifarch x86_64
BuildRequires:	mtools
BuildRequires:	dosfstools
BuildRequires:	genisoimage
BuildRequires:	nasm
BuildRequires:	seabios.git-csm
%endif
BuildRequires:	iasl
BuildRequires:	python
BuildRequires:	libuuid-devel
BuildRequires:	git


%description
EFI Development Kit II

%package tools
Summary:	EFI Development Kit II Tools
%description tools
EFI Development Kit II Tools


%ifarch x86_64
%global subpkgname OVMF

%package -n OVMF 
Summary:	UEFI Firmware for 64-bit virtual machines
License:	BSD and OpenSSL
BuildArch:      noarch

%description -n OVMF
UEFI Firmware for 64-bit virtual machines
%endif


%ifarch aarch64
%global subpkgname AAVMF

%package -n AAVMF 
Summary:	UEFI Firmware for aarch64 virtual machines
License:	BSD
BuildArch:      noarch

%description -n AAVMF 
UEFI Firmware for aarch64 virtual machines
%endif

%prep
%setup -q -n %{name}-%{version}
%ifarch x86_64
git clone -b %{openssl_tag} https://github.com/openssl/openssl CryptoPkg/Library/OpensslLib/openssl
%endif

%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch20 -p1
%patch30 -p1


%build
source ./edksetup.sh

# figure tools switch
GCCVER=$(gcc --version | awk '{ print $3; exit}')
case "$GCCVER" in
4.4*)	CC_FLAGS="-t GCC44";;
4.5*)	CC_FLAGS="-t GCC45";;
4.6*)	CC_FLAGS="-t GCC46";;
4.7*)	CC_FLAGS="-t GCC47";;
4.8*)	CC_FLAGS="-t GCC48";;
4.9*)	CC_FLAGS="-t GCC49";;
5.*)	CC_FLAGS="-t GCC5";;
6.*)	CC_FLAGS="-t GCC5";;
7.*)	CC_FLAGS="-t GCC5";;
8.*)	CC_FLAGS="-t GCC5";;
esac

# parallel builds
SMP_MFLAGS="%{?_smp_mflags}"
if [[ x"$SMP_MFLAGS" = x-j* ]]; then
	CC_FLAGS="$CC_FLAGS -n ${SMP_MFLAGS#-j}"
elif [ -n "%{?jobs}" ]; then
	CC_FLAGS="$CC_FLAGS -n %{?jobs}"
fi

# prepare
make -C BaseTools

# build key encollment boot iso
build_iso()
{
	local ARCH="$1"
	local UEFI_BINDIR=$(
		echo -n Build/Ovmf${ARCH}/DEBUG_*/
		echo $ARCH | tr '[:lower:'] '[:upper:]'
	)
	local UEFI_SHELL_BINARY=$UEFI_BINDIR/Shell.efi
	local ENROLLER_BINARY=$UEFI_BINDIR/EnrollDefaultKeys.efi
	local UEFI_SHELL_IMAGE=uefi_shell_${ARCH}.img
	local ISO_IMAGE=OVMF/UefiShell.iso

	local UEFI_SHELL_BINARY_BNAME=$(basename -- "$UEFI_SHELL_BINARY")
	local UEFI_SHELL_SIZE=$(stat --format=%s -- "$UEFI_SHELL_BINARY")
	local ENROLLER_SIZE=$(stat --format=%s -- "$ENROLLER_BINARY")

	# add 1MB then 10% for metadata
	local UEFI_SHELL_IMAGE_KB=$((
		(UEFI_SHELL_SIZE + ENROLLER_SIZE +
		 1 * 1024 * 1024) * 11 / 10 / 1024
	))

	# create non-partitioned FAT image
	rm -f -- "$UEFI_SHELL_IMAGE"
	/usr/sbin/mkdosfs -C "$UEFI_SHELL_IMAGE" -n UEFI_SHELL -- "$UEFI_SHELL_IMAGE_KB"

	export MTOOLS_SKIP_CHECK=1
	mmd	-i "$UEFI_SHELL_IMAGE"				::efi
	mmd	-i "$UEFI_SHELL_IMAGE"				::efi/boot
	mcopy	-i "$UEFI_SHELL_IMAGE"	"$UEFI_SHELL_BINARY"	::efi/boot/bootx64.efi
	mcopy	-i "$UEFI_SHELL_IMAGE"	"$ENROLLER_BINARY"	::
	mdir	-i "$UEFI_SHELL_IMAGE"	-/			::

	# build ISO with FAT image file as El Torito EFI boot image
	genisoimage -input-charset ASCII -J -rational-rock \
		-efi-boot "$UEFI_SHELL_IMAGE" -no-emul-boot \
		-o "$ISO_IMAGE" -- "$UEFI_SHELL_IMAGE"
}

%ifarch x86_64
# build OVMF
cp /usr/share/seabios.git-csm/bios-csm.bin OvmfPkg/Csm/Csm16/Csm16.bin
for cfg in pure-efi with-csm secboot; do
	OVMF_FLAGS="$CC_FLAGS -D HTTP_BOOT_ENABLE -D FD_SIZE_4MB"

	case "$cfg" in
	with-csm)
		OVMF_FLAGS="$OVMF_FLAGS -D CSM_ENABLE"
		;;
	pure-efi)
		# nothing
		;;
	secboot)
		OVMF_FLAGS="$OVMF_FLAGS -D SECURE_BOOT_ENABLE"
		OVMF_FLAGS="$OVMF_FLAGS -D SMM_REQUIRE"
		OVMF_FLAGS="$OVMF_FLAGS -D EXCLUDE_SHELL_FROM_FD"
		;;
	esac

	build $OVMF_FLAGS -a X64 -p OvmfPkg/OvmfPkgX64.dsc
	mkdir -p "OVMF"
	cp Build/OvmfX64/DEBUG_*/FV/OVMF_CODE.fd OVMF/OVMF_CODE.${cfg}.fd
	cp Build/OvmfX64/DEBUG_*/FV/OVMF_VARS.fd OVMF/OVMF_VARS.${cfg}.fd
	if [ "$cfg" = secboot ]; then
		# For secboot we want an additional var file named 'OVMF_VARS'
		# to be consistent with default OVMF package.
		cp Build/OvmfX64/DEBUG_*/FV/OVMF_VARS.fd OVMF/OVMF_VARS.fd
		build_iso X64
	fi
	rm -rf Build/OvmfX64
done
%endif

%ifarch aarch64
# build AAVMF 
mkdir -p "AAVMF"
# first build "verbose" version - for extra DEBUG output.
build $CC_FLAGS -a AARCH64 \
    -D DEBUG_PRINT_ERROR_LEVEL=0x8040004F \
    -D HTTP_BOOT_ENABLE \
    -p ArmVirtPkg/ArmVirtQemu.dsc
cp Build/ArmVirtQemu-AARCH64/DEBUG_*/FV/QEMU_EFI.fd AAVMF/QEMU_EFI.verbose.fd

build $CC_FLAGS -a AARCH64 \
    -D DEBUG_PRINT_ERROR_LEVEL=0x80000000 \
    -D HTTP_BOOT_ENABLE \
    -p ArmVirtPkg/ArmVirtQemu.dsc
cp Build/ArmVirtQemu-AARCH64/DEBUG_*/FV/*.fd AAVMF
%endif

%install

mkdir -p %{buildroot}%{_bindir}
install	--strip \
	BaseTools/Source/C/bin/EfiRom \
	BaseTools/Source/C/bin/VolInfo \
	%{buildroot}%{_bindir}

# Install License files
mkdir -p %{buildroot}/%{_docdir}/%{subpkgname}/Licenses
cp -a OvmfPkg/License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/OvmfPkg-License.txt
%ifarch x86_64
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/edk2-License.txt
cp -a CryptoPkg/Library/OpensslLib/openssl/LICENSE %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/OpensslLib-License.txt
%endif
%ifarch aarch64
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/FatPkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/IntelFrameworkModulePkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/MdeModulePkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/MdePkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/OptionRomPkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/ShellPkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/ArmPkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/ArmPlatformPkg-License.txt
cp -a License.txt %{buildroot}/%{_docdir}/%{subpkgname}/Licenses/EmbeddedPkg-License.txt
%endif

%ifarch x86_64
mkdir -p %{buildroot}/usr/share/%{subpkgname}
cp -a OVMF/* %{buildroot}/usr/share/%{subpkgname}
cp -a OvmfPkg/README %{buildroot}/%{_docdir}/%{subpkgname}
cp -a OVMF-ol7-changelog.txt %{buildroot}/%{_docdir}/%{subpkgname}
%endif
%ifarch aarch64
mkdir -p %{buildroot}/usr/share/%{subpkgname}
# Pad the binaries and name them similar to the standard AAVMF package
cat AAVMF/QEMU_EFI.verbose.fd /dev/zero | head -c 64m > %{buildroot}/usr/share/%{subpkgname}/AAVMF_CODE.verbose.fd
cat AAVMF/QEMU_EFI.fd /dev/zero | head -c 64m > %{buildroot}/usr/share/%{subpkgname}/AAVMF_CODE.fd
cat AAVMF/QEMU_VARS.fd /dev/zero | head -c 64m > %{buildroot}/usr/share/%{subpkgname}/AAVMF_VARS.fd
cp -a AAVMF-ol7-changelog.txt %{buildroot}/%{_docdir}/%{subpkgname}
%endif

%files tools
%doc BaseTools/UserManuals/EfiRom_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/VolInfo_Utility_Man_Page.rtf
%{_bindir}/*

%defattr(-,root,root,-)

%ifarch x86_64
%files -n OVMF 
%dir /usr/share/%{subpkgname}
/usr/share/%{subpkgname}
%endif

%ifarch aarch64
%files -n AAVMF
%dir /usr/share/%{subpkgname}
/usr/share/%{subpkgname}
%endif

%dir %{_docdir}/%{subpkgname}/Licenses
%doc %{_docdir}/%{subpkgname}/Licenses/OvmfPkg-License.txt

%ifarch x86_64
%doc %{_docdir}/%{subpkgname}/Licenses/OpensslLib-License.txt
%doc %{_docdir}/%{subpkgname}/Licenses/edk2-License.txt
%doc %{_docdir}/%{subpkgname}/README
%doc %{_docdir}/%{subpkgname}/OVMF-ol7-changelog.txt
%endif

%ifarch aarch64
%doc %{_docdir}/%{subpkgname}/Licenses/FatPkg-License.txt
%doc %{_docdir}/%{subpkgname}/Licenses/IntelFrameworkModulePkg-License.txt
%doc %{_docdir}/%{subpkgname}/Licenses/MdeModulePkg-License.txt
%doc %{_docdir}/%{subpkgname}/Licenses/MdePkg-License.txt
%doc %{_docdir}/%{subpkgname}/Licenses/OptionRomPkg-License.txt
%doc %{_docdir}/%{subpkgname}/Licenses/ArmPkg-License.txt
%doc %{_docdir}/%{subpkgname}/Licenses/ArmPlatformPkg-License.txt
%doc %{_docdir}/%{subpkgname}/Licenses/EmbeddedPkg-License.txt
%doc %{_docdir}/%{subpkgname}/Licenses/ShellPkg-License.txt
%doc %{_docdir}/%{subpkgname}/AAVMF-ol7-changelog.txt
%endif


%changelog
* Thu Aug 9 2018 Aaron Young <Aaron.Young@oracle.com> - 1:1.1-1.el7
- spec: Update spec file and patches to match currently released OVMF/AAVMF
  RPMs.

